<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 3.6 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="./">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 3.6: Water lock case plant models</h1>
                    <p>
                        In the first module, we made a start on the water lock case.
                        We identified seven different types of components, and we made a start on modeling them.
                        In the second module, we adapted the models to be more realistic, using among others synchronizing automata and algebraic variables.
                    </p>
                    <p>
                        In the second module, we also noted that several components have quite similar automata.
                        And we concluded that it was burdensome and error-prone to make and adapt each one individually.
                        In this module, you learned about parameterized component definitions and instantiations, which can be used to reduce the duplication.
                    </p>
                    <p>
                        In this module, you also learned about groups, that can be used to add structure to models.
                        And you learned about imports, that can be used to divide models into separate files, which is useful for larger models and for reuse.
                        And finally, you learned about plant models, controllable and uncontrollable events, as well various properties to which a proper supervisor should adhere.
                    </p>
                    <p>
                        You will now improve the models for the water lock case, by making use of these new modeling features.
                        At the end of this module, you will have the complete plant model for the water lock case.
                    </p>

                    <h2>Two CIF files</h2>
                    <p>
                        We will divide the CIF model for the water lock case over two CIF files:
                    </p>
                    <ul>
                        <li>File <code>plant_definitions.cif</code>, containing all the automaton and group definitions for the different components of the water lock (bridges, gates, lights, etc).</li>
                        <li>File <code>plant.cif</code>, containing the instantiations that define the form the actual plant.</li>
                    </ul>
                    <p>
                        The definitions file is imported into the plant file.
                        This approach gives a clear structure, makes it easier to find the different parts of the model and reduces duplication.
                        The different kinds of components are defined once in the definitions file, and the actual plant is easily built in the plant file through instantiations.
                        The resulting model can be easily adapted and extended.
                    </p>

                    <h2>Assignment 1</h2>
                    <p>
                        Look at your answers to the water lock case <a href="../module2/more-detailed-models-water-lock-case.html">assignments of the second module</a>.
                        There, you modeled all components of the water lock, such as the bridges, gates, and so on, as well as their sub-components, the sensors and actuators.
                        As mentioned before, you will adapt these models to make use of component definitions and instantiations.
                    </p>
                    <p>
                        Identify how many automaton definitions you need to make, for each sub-component type.
                        Does, for example, one definition suffice to model all sensors or do you need multiple definitions for different kinds of sensors?
                        Also, think of how definitions should be made for the components.
                        For example, do you need group/automaton definitions and instantiations for them?
                    </p>
                    <div class="accordion" id="assignment1-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment1-solution" aria-expanded="false" aria-controls="assignment1-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment1-solution" class="accordion-collapse collapse" data-bs-parent="#assignment1-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Looking at the solutions provided for the assignments in the second module, all sensors of the traffic lights are similar in structure.
                                        However, the sensors of the open/closed components are structurally different.
                                        Two different definitions should thus be modeled, one for the sensors of the traffic lights, and one for the the sensors of the open/closed components.
                                    </p>
                                    <p>
                                        The actuators of the entering, leaving, and bridge traffic lights, as well as those of the open/closed components, are all different in structure.
                                        Their definitions need to be modeled separate.
                                        You thus need to model two sensor definitions and four actuator definitions.
                                    </p>
                                    <p>
                                        Components contain sub-components.
                                        For instance, the entering traffic lights consist of three sensors and one actuator.
                                        It is thus best to model the components of the water lock as group definitions.
                                        Within the group definitions, there are then automaton instantiations for the sub-components.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 2</h2>
                    <p>
                        Model the automaton and group definitions of the entering, leaving and bridge traffic light actuators.
                        Don't forget to define the events as being either controllable or uncontrollable.
                    </p>
                    <div class="accordion" id="assignment2-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment2-solution" aria-expanded="false" aria-controls="assignment2-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment2-solution" class="accordion-collapse collapse" data-bs-parent="#assignment2-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The automata are now defined as automaton definitions.
                                        Since they are part of the plant, they are defined as plant automata definitions.
                                        All the events are controllable, and the supervisor is allowed to enable or disable the actuators of the system.
                                        The event names are prefixed with <code>c_</code>.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def EnteringTLActuator():
                                                controllable c_to_red_red, c_to_red, c_to_red_green, c_to_green;

                                                location Red:
                                                    initial;
                                                    marked;
                                                    edge c_to_red_red   goto RedRed;
                                                    edge c_to_red_green goto RedGreen;
                                                    edge c_to_green     goto Green;

                                                location RedRed:
                                                    marked;
                                                    edge c_to_red       goto Red;
                                                    edge c_to_red_green goto RedGreen;
                                                    edge c_to_green     goto Green;

                                                location RedGreen:
                                                    edge c_to_red       goto Red;
                                                    edge c_to_red_red   goto RedRed;
                                                    edge c_to_green     goto Green;

                                                location Green:
                                                    edge c_to_red       goto Red;
                                                    edge c_to_red_red   goto RedRed;
                                                    edge c_to_red_green goto RedGreen;
                                            end

                                            plant def LeavingTLActuator():
                                                controllable c_to_green, c_to_red;

                                                location Red:
                                                    initial;
                                                    marked;
                                                    edge c_to_green goto Green;

                                                location Green:
                                                    edge c_to_red   goto Red;
                                            end

                                            plant def BridgeTLActuator():
                                                controllable c_to_on, c_to_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge c_to_on  goto On;

                                                location On:
                                                    edge c_to_off goto Off;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 3</h2>
                    <p>
                        Now consider the definitions for the traffic light sensors.
                        Looking at the models from the second module, for some traffic light sensors the <code>On</code> location is the initial and marked location, while for others it is the <code>Off</code> location.
                        To allow for this flexibility, add a boolean parameter to the sensor definition.
                    </p>
                        Hint: A location can be made conditionally initial, by placing a predicate after the location's <code>initial</code> keywords.
                        If the predicate evaluates to <code>true</code>, the location is initial, otherwise it is not.
                        Similarly, a location can be conditionally marked.
                    </p>
                    <p>
                        Furthermore, not all sensors have the same guards for their edges.
                        For instance, some sensors will go on when the corresponding light is green and others when it is red.
                        Parameterize the definition by adding two more parameters, one representing the guard for going on, and one for going off.
                    </p>
                    <p>
                        With the above considerations in mind, model a single definition that can be used for all traffic light sensors.
                        And also here, don't forget to define the events as being either controllable or uncontrollable.
                    </p>
                    <div class="accordion" id="assignment3-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment3-solution" aria-expanded="false" aria-controls="assignment3-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment3-solution" class="accordion-collapse collapse" data-bs-parent="#assignment3-accordion">
                                <div class="accordion-body">
                                    <p>
                                        As with the actuators, the automata are now defined as plant automaton definitions.
                                        The events are all uncontrollable, since the supervisor is not allowed to disable sensor events.
                                        The event names are prefixed with <code>u_</code>.
                                    </p>
                                    <p>
                                        The definition has three boolean algebraic parameters.
                                        Since they are of the same type, the type needs to be specified only once.
                                    </p>
                                    <p>
                                        The <code>initial_on</code> parameter indicates whether the sensor is initially on.
                                        The <code>On</code> location is made conditionally initial and marked, based on this variable being <code>true</code>.
                                        Note that we simply use condition <code>initial_on</code>, instead of condition <code>initial_on = true</code>, as they are functionally identical and the former is shorter.
                                        The <code>Off</code> location is similarly made conditionally initial and marked, but with the negated condition.
                                    </p>
                                    <p>
                                        The <code>guard_go_on</code> and <code>guard_go_off</code> parameters indicate when the sensor goes on and off, respectively.
                                        They are used as guards of the edges.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Sensor(alg bool initial_on, guard_go_on, guard_go_off):
                                                uncontrollable u_go_on, u_go_off;

                                                location On:
                                                    initial initial_on;
                                                    marked  initial_on;
                                                    edge u_go_off when guard_go_off goto Off;

                                                location Off:
                                                    initial not initial_on;
                                                    marked  not initial_on;
                                                    edge u_go_on  when guard_go_on  goto On;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 4</h2>
                    <p>
                        Having completed the definitions of the traffic light actuators and sensors, now you are going to model a definition for an entire leaving traffic light.
                        Look again at the solutions in the second module, to see what which components are part of the leaving traffic lights and how they behave.
                    </p>
                    <p>
                        Model the entire leaving traffic light as a group definition that combines the sub-components.
                        When defining the automaton instantiations, think of the right argument values to use for the parameters of the automaton definitions.
                        Also, add algebraic boolean variables that indicate whether the light is green or red, as in the second module.
                    </p>
                    <div class="accordion" id="assignment4-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment4-solution" aria-expanded="false" aria-controls="assignment4-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment4-solution" class="accordion-collapse collapse" data-bs-parent="#assignment4-accordion">
                                <div class="accordion-body">
                                    <p>
                                        We name the group definition <code>LeavingTL</code>, to match <code>LeavingTLActuator</code>.
                                        We use <code>Actuator</code> as name for the instantiation of <code>LeavingTLActuator</code>, since it is the only actuator of the leaving traffic light.
                                        Also, since it is part of the group definition, there is no need to repeat <code>LeavingTL</code>.
                                    </p>
                                    <p>
                                        We keep the names of the two sensors.
                                        The leaving traffic light is initially red.
                                        We therefore provide <code>true</code> for the <code>initial_on</code> parameter of the <code>Sensor</code> definition, for <code>SensorRed</code>.
                                        It is then not initially green, so we provide <code>false</code> for <code>SensorGreen</code>.
                                        We also provide the guard predicates for the sensors going on and off.
                                    </p>
                                    <p>
                                        The algebraic variables are kept as they were in the second module, but have been updated to account for the change in the actuator name.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group def LeavingTL():
                                                Actuator:    LeavingTLActuator();
                                                SensorGreen: Sensor(false, Actuator.Green, Actuator.Red);
                                                SensorRed:   Sensor(true,  Actuator.Red,   Actuator.Green);

                                                alg bool IsRed   = Actuator.Red   and SensorGreen.Off and SensorRed.On;
                                                alg bool IsGreen = Actuator.Green and SensorGreen.On  and SensorRed.Off;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 5</h2>
                    <p>
                        Model the definition for the entering and bridge traffic lights, just as you did in Assignment 4 for the leaving traffic lights.
                        Do not forget the algebraic variables indicating the state of the lights.
                    </p>
                    <div class="accordion" id="assignment5-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment5-solution" aria-expanded="false" aria-controls="assignment5-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment5-solution" class="accordion-collapse collapse" data-bs-parent="#assignment5-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group def BridgeTL():
                                                Actuator:  BridgeTLActuator();
                                                SensorOn:  Sensor(false, Actuator.On,  Actuator.Off);
                                                SensorOff: Sensor(true,  Actuator.Off, Actuator.On);

                                                alg bool IsOn  = Actuator.On  and SensorOn.On  and SensorOff.Off;
                                                alg bool IsOff = Actuator.Off and SensorOn.Off and SensorOff.On;
                                            end

                                            group def EnteringTL():
                                                Actuator:        EnteringTLActuator();
                                                SensorTopRed:    Sensor(true,  not Actuator.Green,                          Actuator.Green);
                                                SensorGreen:     Sensor(false,     Actuator.RedGreen or Actuator.Green,     Actuator.Red or Actuator.RedRed);
                                                SensorBottomRed: Sensor(false,     Actuator.RedRed,                     not Actuator.RedRed);

                                                alg bool IsRed      = Actuator.Red      and SensorTopRed.On  and SensorGreen.Off and SensorBottomRed.Off;
                                                alg bool IsRedRed   = Actuator.RedRed   and SensorTopRed.On  and SensorGreen.Off and SensorBottomRed.On;
                                                alg bool IsRedGreen = Actuator.RedGreen and SensorTopRed.On  and SensorGreen.On  and SensorBottomRed.Off;
                                                alg bool IsGreen    = Actuator.Green    and SensorTopRed.Off and SensorGreen.On  and SensorBottomRed.Off;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 6</h2>
                    <p>
                        Looking again at the second module, an open/closed component has different sensors and actuators than the other components.
                        In the second module, you already modeled this.
                        Now, make definitions for its sub-components.
                        Use component parameters for allow the sensor and actuator to use information about each other's state.
                        Also parameterize the sensor with a parameter that indicates whether the open/closed component is initially closed.
                    </p>
                    <div class="accordion" id="assignment6-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment6-solution" aria-expanded="false" aria-controls="assignment6-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment6-solution" class="accordion-collapse collapse" data-bs-parent="#assignment6-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def OpenClosedActuator(OpenClosedSensor sensor):
                                                controllable c_start_opening, c_stop_opening, c_start_closing, c_stop_closing;

                                                location Idle:
                                                    initial;
                                                    marked;
                                                    edge c_start_opening when not sensor.Open   goto Opening;
                                                    edge c_start_closing when not sensor.Closed goto Closing;

                                                location Opening:
                                                    edge c_stop_opening  when     sensor.Open   goto Idle;

                                                location Closing:
                                                    edge c_stop_closing  when     sensor.Closed goto Idle;
                                            end

                                            plant def OpenClosedSensor(alg bool initial_closed; OpenClosedActuator actuator):
                                                uncontrollable u_closed, u_not_closed, u_open, u_not_open;

                                                location Closed:
                                                    initial initial_closed;
                                                    marked  initial_closed;
                                                    edge u_not_closed when actuator.Opening goto Intermediate;

                                                location Intermediate:
                                                    edge u_closed     when actuator.Closing goto Closed;
                                                    edge u_open       when actuator.Opening goto Open;

                                                location Open:
                                                    initial not initial_closed;
                                                    marked  not initial_closed;
                                                    edge u_not_open   when actuator.Closing goto Intermediate;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 7</h2>
                    <p>
                        Make a definition for an entire open/closed component, with its two sub-components and three algebraic variables.
                        Use again a group definition and parameterize it to allow an open/closed component to be initially open or closed.
                    </p>
                    <div class="accordion" id="assignment7-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment7-solution" aria-expanded="false" aria-controls="assignment7-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment7-solution" class="accordion-collapse collapse" data-bs-parent="#assignment7-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group def OpenClosedComponent(alg bool initial_closed):
                                                Actuator: OpenClosedActuator(Sensor);
                                                Sensor:   OpenClosedSensor(initial_closed, Actuator);

                                                alg bool IsMoving = not Actuator.Idle;
                                                alg bool IsOpen   = Sensor.Open;
                                                alg bool IsClosed = Sensor.Closed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 8</h2>
                    <p>
                        Having completed the plant definitions of the water lock case in <code>plant_definitions.cif</code>, it is now time to model the actual plant in <code>plant.cif</code>.
                    </p>
                    <p>
                        The Westsluis water lock is symmetric: the north and south sides of the lock contain the same components.
                        Model one side of the lock using instantiations.
                        Group components of the same type, like multiple culverts.
                        Model the traffic barriers as being initially open, and the other open/closed components as being initially closed.
                    </p>
                    <div class="accordion" id="assignment8-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment8-solution" aria-expanded="false" aria-controls="assignment8-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment8-solution" class="accordion-collapse collapse" data-bs-parent="#assignment8-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            Gate: OpenClosedComponent(true);

                                            Bridge: OpenClosedComponent(true);

                                            group Culverts:
                                                East: OpenClosedComponent(true);
                                                West: OpenClosedComponent(true);
                                            end

                                            group TrafficBarriers:
                                                East: OpenClosedComponent(false);
                                                West: OpenClosedComponent(false);
                                            end

                                            group EnteringTLs:
                                                East: EnteringTL();
                                                West: EnteringTL();
                                            end

                                            group LeavingTLs:
                                                East: LeavingTL();
                                                West: LeavingTL();
                                            end

                                            group BridgeTLs:
                                                East: BridgeTL();
                                                West: BridgeTL();
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 9</h2>
                    <p>
                        Since the north and south side of the lock are the same, turn the solution to Assignment 8 into a definition.
                        Then, instantiate it for each side, to complete the plant model.
                    </p>
                    <p>
                        For components of the same type that you grouped, add algebraic variables indicating the state of both the east and west components.
                        For instance, define an algebraic variable <code>Open</code> for the culverts, which is <code>true</code> when both the east and west culvert are open.
                        We will use these algebraic variables in the next module.
                    </p>
                    <div class="accordion" id="assignment9-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment9-solution" aria-expanded="false" aria-controls="assignment9-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment9-solution" class="accordion-collapse collapse" data-bs-parent="#assignment9-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group def Side():
                                                Gate: OpenClosedComponent(true);

                                                Bridge: OpenClosedComponent(true);

                                                group Culverts:
                                                    East: OpenClosedComponent(true);
                                                    West: OpenClosedComponent(true);

                                                    alg bool IsOpen   = East.IsOpen   and West.IsOpen;
                                                    alg bool IsClosed = East.IsClosed and West.IsClosed;
                                                end

                                                group TrafficBarriers:
                                                    East: OpenClosedComponent(false);
                                                    West: OpenClosedComponent(false);

                                                    alg bool IsOpen   = East.IsOpen   and West.IsOpen;
                                                    alg bool IsClosed = East.IsClosed and West.IsClosed;
                                                end

                                                group EnteringTLs:
                                                    East: EnteringTL();
                                                    West: EnteringTL();

                                                    alg bool IsRed      = East.IsRed      and West.IsRed;
                                                    alg bool IsRedRed   = East.IsRedRed   and West.IsRedRed;
                                                    alg bool IsRedGreen = East.IsRedGreen and West.IsRedGreen;
                                                    alg bool IsGreen    = East.IsGreen    and West.IsGreen;
                                                end

                                                group LeavingTLs:
                                                    East: LeavingTL();
                                                    West: LeavingTL();

                                                    alg bool IsRed   = East.IsRed   and West.IsRed;
                                                    alg bool IsGreen = East.IsGreen and West.IsGreen;
                                                end

                                                group BridgeTLs:
                                                    East: BridgeTL();
                                                    West: BridgeTL();

                                                    alg bool IsOn  = East.IsOn  and West.IsOn;
                                                    alg bool IsOff = East.IsOff and West.IsOff;
                                                end
                                            end

                                            North: Side();
                                            South: Side();
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 10</h2>
                    <p>
                        The lock has various commands that allow the operator to control the it.
                        For instance, the north gate may only be opened after the operator requests it to be opened.
                        So far, in modeling the plants, we have ignored these commands.
                    </p>
                    <p>
                        You did see these commands in the first module, when you simulated the lock to find undesired behavior.
                        Simulate it again, as you did in the first module, if you don't remember what commands an operator can give to the system.
                        Note that some commands control multiple components of the system.
                    </p>
                    <p>
                        Model a plant definition for a command.
                        A command can be requested by the operator.
                        The system will then give the supervisor the opportunity to process the command.
                        However, the supervisor may have disabled the command, if it is unsafe.
                        After a brief time, the system will, by itself, unrequest the command.
                    </p>
                    <p>
                        Instantiate the definition it as many times as needed for the various components of the lock that can be controlled.
                    </p>
                    <div class="accordion" id="assignment10-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment10-solution" aria-expanded="false" aria-controls="assignment10-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment10-solution" class="accordion-collapse collapse" data-bs-parent="#assignment10-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>plant_definitions.cif</code> file is extended with one extra definition:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Command():
                                                uncontrollable u_request, u_unrequest;

                                                location NotRequested:
                                                    initial;
                                                    marked;
                                                    edge u_request goto Requested;

                                                location Requested:
                                                    edge u_unrequest goto NotRequested;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        A command can be requested and unrequested.
                                        The request is uncontrollable, since the operator does the request and the supervisor can't prevent it.
                                        After some time, the system unrequests the command.
                                        The supervisor can't prevent this either, so that is also modeled as an uncontrollable event.
                                    </p>
                                    <p>
                                        The <code>plant.cif</code> file is updated as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "plant_definitions.cif";

                                            group def Side():
                                                Gate: OpenClosedComponent(true);

                                                GateOpenCommand:  Command();
                                                GateCloseCommand: Command();

                                                Bridge: OpenClosedComponent(true);

                                                BridgeOpenCommand:  Command();
                                                BridgeCloseCommand: Command();

                                                group Culverts:
                                                    East: OpenClosedComponent(true);
                                                    West: OpenClosedComponent(true);

                                                    OpenCommand:  Command();
                                                    CloseCommand: Command();

                                                    alg bool IsOpen   = East.IsOpen   and West.IsOpen;
                                                    alg bool IsClosed = East.IsClosed and West.IsClosed;
                                                end

                                                group TrafficBarriers:
                                                    East: OpenClosedComponent(false);
                                                    West: OpenClosedComponent(false);

                                                    OpenCommand:  Command();
                                                    CloseCommand: Command();

                                                    alg bool IsOpen   = East.IsOpen   and West.IsOpen;
                                                    alg bool IsClosed = East.IsClosed and West.IsClosed;
                                                end

                                                group EnteringTLs:
                                                    East: EnteringTL();
                                                    West: EnteringTL();

                                                    RedCommand:      Command();
                                                    RedRedCommand:   Command();
                                                    RedGreenCommand: Command();
                                                    GreenCommand:    Command();

                                                    alg bool IsRed      = East.IsRed      and West.IsRed;
                                                    alg bool IsRedRed   = East.IsRedRed   and West.IsRedRed;
                                                    alg bool IsRedGreen = East.IsRedGreen and West.IsRedGreen;
                                                    alg bool IsGreen    = East.IsGreen    and West.IsGreen;
                                                end

                                                group LeavingTLs:
                                                    East: LeavingTL();
                                                    West: LeavingTL();

                                                    RedCommand:   Command();
                                                    GreenCommand: Command();

                                                    alg bool IsRed   = East.IsRed   and West.IsRed;
                                                    alg bool IsGreen = East.IsGreen and West.IsGreen;
                                                end

                                                group BridgeTLs:
                                                    East: BridgeTL();
                                                    West: BridgeTL();

                                                    OnCommand:  Command();
                                                    OffCommand: Command();

                                                    alg bool IsOn  = East.IsOn  and West.IsOn;
                                                    alg bool IsOff = East.IsOff and West.IsOff;
                                                end
                                            end

                                            North: Side();
                                            South: Side();
                                        </code>
                                    </pre>
                                    <p>
                                        The gate and bridge get open and close commands, as do the culverts and traffic barriers.
                                        The entering traffic lights get commands to switch the lights, as do the leaving traffic lights and bridge traffic lights.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Final remarks</h2>
                    <p>
                        Congratulations, you have completely modeled the plant of the Westsluis water lock case.
                        Hopefully, you have realized that the use of component definitions/instantiations, groups and imports can greatly improve the structure of a plant model, making it more readable and adaptable.
                        However, this plant model still has dangerous behavior, as we saw in the first module.
                        In the next module, we will add requirements and synthesize a supervisor to prevent this unsafe behavior.
                    </p>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="exercises.html">Go back to Module 3.5</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="../module4">Proceed to Module 4</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
